;--------------------------------------------------------
;       DisplayTitle  ( Aps/As3/BA3/BX3/486X-matep )
;--------------------------------------------------------
DisplayTitle    PROC    near
                push    ROW
                push    COLUMN
                mov     ROW,0
                mov     COLUMN,57
                mov     dx,offset location_msg
                call    _puts
                mov     ax,cs:[00F8h]
                call    digitx
                pop     COLUMN
                pop     ROW

                mov     dx,offset title_msg
                call    _puts
                mov     dx,offset msg_mactype
                call    _puts
                
                mov     al,MachineType
                cmp     al,1
                je      MachineType1
                cmp     al,2
                je      MachineType2
                cmp     al,3
                je      MachineType3
                cmp     al,5
                je      MachineType5
                cmp     al,4
                je      MachineType4

                mov     dx,offset machine_typeUN
                mov     al,1
                mov     MachineType,al
                jmp     @f

MachineType1:   mov     dx,offset machine_typeB3
                jmp     @f
MachineType2:   mov     dx,offset machine_typeX
                jmp     @f
MachineType3:   mov     dx,offset machine_typeA3
                jmp     @f
MachineType5:   mov     dx,offset machine_typeC
                jmp     @f
MachineType4:   mov     dx,offset machine_typeAn
                jmp     @f
MachineType9:   mov     dx,offset machine_typeXa
;               jmp     @f
        @@:     call    _puts
                mov     dx,offset msg_CRLF
                call    _puts
                ret
DisplayTitle    ENDP
location_msg    DB      0E1h,"EXIDE ROM̾=",0
IF 0
;--------------------------------------------------------
;       NOPCI_Check
;--------------------------------------------------------
NOPCI_Check     PROC    near
                xor     dx,dx
                mov     ax,0B101h       ; Get PCI BIOS status
                int     1Ah             ; PCI BIOS call
                jc      PCI_Check_fail
                cmp     dx,20494350h    ; ?dx=='PCI '
                jnz     PCI_Check_fail
                STC
                ret
PCI_Check_fail: CLC
                ret
NOPCI_Check     ENDP
ENDIF

;--------------------------------------------------------
;       SetDisplayLine  
;--------------------------------------------------------
SetDisplayLine  PROC   near
                push    ds
                mov     ax,ROW
                mov     ds,SegTVRAM
                mov     ds:[3FE0h],al    ; [ITF\sǗAhX]
                pop     ds
                ret
SetDisplayLine  ENDP


;--------------------------------------------------------
;       ShiftKeyCheck
;--------------------------------------------------------
ShiftKeyCheck   PROC    near
LoopPressShift: mov     ah,02h
                int 18h
                test    al,00011001b    ; 1=SHIFT, 8=GRPH, 16=CTRL
                jnz     LoopPressShift
                ret
ShiftKeyCheck   ENDP

;---------------------------------------------------------------------
;       Sector256Byte  256oCgݒ肩ǂ Ap3,486X(2䑕\@)p
;---------------------------------------------------------------------
Sector256Byte   PROC   near
                mov     dx,841Eh        ; \tgEFADIPXCb`
                in      al,dx
                and     al,01000000b    ; bit 6Y
                jz      Exist256BS      ; [Ȃ256Byte/sector
                clc
                ret
Exist256BS:     mov     dx,offset msg_Sector256B
                call    _puts
                stc
                ret
Sector256Byte   ENDP


;--------------------------------------------------------
;       GetDisplayLine       input   ES = VRAM segment
;--------------------------------------------------------
GetDisplayLine  PROC    near
                xor     ax,ax
                mov     ROW,MSG_DISP_LINE
                mov     COLUMN,ax
                mov     bx,3FE0h                ; ITF\sǗAhX
                mov     al,es:[bx]
                cmp     al,MSG_DISP_LINE
                ja      LineIndicatorInvalid
                inc     ax
                mov     ROW,ax
LineIndicatorInvalid:
                mov     ax,ROW
                mov     StartLine,al
                ret
GetDisplayLine  ENDP

;--------------------------------------------------------
;       Exist_IDE_BIOS
;--------------------------------------------------------
Exist_IDE_BIOS  PROC   near
                push    es
                mov     es,SegPhysIDEBIOS
                mov     ax,es:[0009h]   ; ? C-BUS ROM
                mov     bx,es:[000Bh]   ; ? C-BUS ROM
                mov     edx,es:[0030h]  ; ? $PnP
                pop     es
                cmp     ax,0AA55h       ; C-BUS ROM signature
                jnz     NoExist_IDE_BIOS
                cmp     bl,2Ah          ; C-BUS ROM type ID
                jnz     NoExist_IDE_BIOS
                or      edx,edx         ; jmp [0030] == 00000000h
                jz      NoExist_IDE_BIOS

;                mov     dx,offset IDE_msg ; uIDE BIOS܂v
;                call    _puts
                clc
                ret
NoExist_IDE_BIOS:  
                mov     dx,offset absent_msg
                call    _puts
                stc
                ret
Exist_IDE_BIOS  ENDP

;---------------------------------------------------------------------
;       Get segment address of IDE BIOS   ɂP񂾂R[
;---------------------------------------------------------------------
GetSeg_IDEBIOS  PROC    near
                mov     al,HiresoFlag
                test    al,1        ; --- Normal mode ---
                mov     cx,0DA00h   ; IDE work address (physical)
                mov     dx,0D800h   ; IDE BIOS address (physical)
                mov     ax,09800h   ; IDE BIOS address of memory window
                jz      NormalMode_IDE
                mov     cx,0E800h   ; IDE work address (physical)
                mov     bx,0E600h   ; IDE BIOS address (physical),ordinary
                mov     dx,063Dh
                in      al,dx
                test    al,2
                jz      @f
;;;             add     OffsetXcode,2000h       ; using adapter 
                mov     cx,0EA00h   ; IDE work address (physical)
        @@:     mov     dx,bx       ; 
                sub     bx,6000h    ; phisycal --> shadow
                mov     ax,bx       ; IDE BIOS address of memory window
NormalMode_IDE: mov     SegPhysIDEBIOS,dx
                mov     SegPhysIDEwork,cx
                mov     SegMMapIDEBIOS,ax
;                mov     es,ax
                ret
GetSeg_IDEBIOS  ENDP



;--------------------------------------------------------------------
;       scan_pattern     ̔r[`    for IDE BIOS
;       <input>
;       DS:SI rp^[,         CX p^[̃oCg
;       ES:DI p^[ꏊ,         DX ͈̔̓oCg
;       <output>        < j AX,BX,CX,DX,DI >
;       CY =NONE ,  NC= ES:BX   carry0̂Ƃ  ES:BXɌoꏊԂ
;--------------------------------------------------------------------
scan_pattern     PROC    near
                cld
                mov     di,0040h
                sub     cx,si
                mov     dx,2000h-40h
                sub     dx,cx

                xor     bx,bx
                add     dx,di
scan_ent:       mov     ax,ds:[si]
                cmp     ax,es:[di]
                jnz     scan_No_match
                mov     bx,di
                push    cx
                push    si
                push    di
         repz   cmpsb
                or      cx,cx
                pop     di
                pop     si
                pop     cx
                jnz     scan_No_match
                clc                     ; scan OK
                ret
scan_No_match:  inc     di
                cmp     di,dx
                jb      scan_ent
                stc                     ; scan NG
                ret
scan_pattern    ENDP

;---------------------------------------------------------
Tone98Set       PROC    near
                push    dx
                mov DX,03FDBh        ; 3FDB
                out DX,AL
                out     5Fh,al
               xchg AL,AH
                out DX,AL
                out     5Fh,al
                pop     dx
                ret
Tone98Set       ENDP
;--------------------------------------------------------
;--------------------------------------------------------
BeepSound       PROC   near
                call    Tone98Set
                mov     al,6            ; BEEP ON
                out 37h,al              
                mov     cx,bx
        @@:     out     5Fh,al  ; ҂
                out     5Fh,al
               loop     @b
                mov     al,7            ; BEEP OFF
                out 37h,al              
                mov     ax,04CDh        ; normal freq.
                call    Tone98Set
                ret
BeepSound       ENDP
;--------------------------------------------------------
;       Poop
;--------------------------------------------------------
Poop            PROC   near
                push    ax
                push    dx
                push    cx
                push    bx
                mov     ax,5000
                mov     bx,6543h 
                call    BeepSound
                pop     bx
                pop     cx
                pop     dx
                pop     ax
                ret
Poop            ENDP
;--------------------------------------------------------
;       Peee
;--------------------------------------------------------
Peee            PROC   near
                push    ax
                push    dx
                push    cx
                push    bx
                mov     ax,3750
                mov     bx,0FFF0h 
                call    BeepSound
                pop     bx
                pop     cx
                pop     dx
                pop     ax
                ret
Peee            ENDP
IF 0
;--------------------------------------------------------
;       ClearMEMseg
;--------------------------------------------------------
ClearMEMseg     PROC    near
                push    es
                mov     cx,2000h/2
                mov     ax,MEMseg
                mov     es,ax
                xor     ax,ax
                mov     di,ax
           rep  stosw
                pop     es
                ret
ClearMEMseg     ENDP
ENDIF
;----------------------------------------------------------------------
;       ResoModeCheck   ŏɂP񂾂Ăяo`FbN output ES
;----------------------------------------------------------------------
ResoModeCheck   PROC    near
                mov     MemWindowAddr,0Ch
                mov     MemWindowNative,08h
                mov     mem_bank_IOaddr,0461h
                xor     ax,ax
                mov     es,ax
                mov     al,es:[0501h]           ; hi-reso check
                and     al,8    ; 1000b           1      0
                shr     al,2    ;   10b                  0
                add     MemWindowAddr,al        ; 0Eh    0Ch
                shr     al,1    ;    1b
                mov     HiresoFlag,al            ; high/low mode flag
                mov     dx,0A000h       ; Text VRAMZOg
                mov     bx,0F8E8h       ; Machine ID i[ZOg(BIOS)
                mov     ah,00h          ; AH bit 7MAchine ID̈ꕔɎg
                or      al,al
                jz      NormalResoMode  
; HIRESOLUTION MODE SETTINGS
                mov     mem_bank_IOaddr,0091h ; Hireso mem-window port
                mov     MemWindowNative,10h;  Hireso mem-window native addr
                mov     dx,0E000h       ; The segment of Text VRAM at H mode
                mov     bx,0FFE8h       ; The segment of Machine ID flag at H.
                mov     ah,80h          ; bit7=1 , Machine IDmnC]rbg
NormalResoMode: mov     es,dx           
                mov     SegTVRAM,dx     ; TEXT VRAMZOgLϐɊi[
                push    ds
                mov     ds,bx
                mov     al,ds:[003Fh]
                pop     ds
                or      al,ah           ; nC]bitƍ
                mov     MachineID,al
                ret
ResoModeCheck   ENDP

;----------------------------------------------------
;       ChkCPU
;----------------------------------------------------
CheckCPU        PROC   near
                xor     ax,ax
                push    ds
                mov     ds,ax
                mov     ax,ds:[0486h]
                pop     ds
                or      ax,ax
                jz      WrongCPU
                cmp     ax,04F4h        ; Am5x86 WB x4 speed
                je      start_WB
                cmp     ax,0494h        ; Am5x86 WB x3 speed 
                je      start_WB
                cmp     ax,0490h        ; WBE DX4-100 SK096 (fixed on Dec.2022)
                je      start_WB
                and     ax,0F00h
                cmp     ax,0500h
                jb      NotPentium
                out     dx,al
                clc
NotPentium:     ret
start_WB:       mov     dx,063Fh
                in      al,dx
                or      al,10000000b
                out     dx,al
                clc
                ret
WrongCPU:       stc
                ret
CheckCPU        ENDP


